# How to find more SFZ instruments

The main manual listed a couple of good SFZ Instruments that work well with SFZ Player. But there are a lot of them out there. The harder you look, the more you will find. Here we will list a few ideas.

## Curated lists of good SFZ

This list of good SFZ instruments has been around for a while. We haven't tried all of them, but the ones we have tried worked well and sounded good: https://www.laptopmusician.net/2019/06/the-ultimate-free-sfz-instruments-list.html

The Sfz format site has a list of free SFZ. We haven't tried them, but it seems like a good list: https://sfzinstruments.github.io

## Very good SFZ that don't work so well in SFZ Player

Unreal Instruments Metal GTX guitar. SFZ Player cannot play most of the Unreal Instruments SFZ Instruments. For reference, they are [here](https://unreal-instruments.wixsite.com/unreal-instruments)

Pianobook is an incredible collection of free samples. Some of them are available as SFZ. Unfortunately the ones we tried are also too complex for SFZ Player. They are [here](https://www.pianobook.co.uk/).

The free sounds that come with the Szforzando player are in aria format, we we can't play those.

## Commercial SFZ Instruments

Some commercial venders sell SFZ instruments. Many of the Samples From Mars collection work well. They tend to emphasize samples of vintage drum machines.

Garritan sells some very advanced SFZ Instruments, but their libraries all use some form of encryption, so they won't play in SFZ Player.

## Make your own mappings

For every free SFZ Instrument you might find, there are many, many free sample sets that do not provide an SFZ mapping. If you learn how to make your own SFZ it can be pretty easy to put together an SFZ Instrument that uses them. Here is some useful information on [making SFZ](./sfz-player-make.md)

## Find SFZ mappings

It is quite common for people to hand craft their own SFZ files to go along with some other collection of free samples. They might do this because they don't like the original mappings, or perhaps there were no SFZ mappings.

In our limited experience these are often too complex for SFZ Player to play, that that isn't always the case.

There are a bunch here: https://github.com/sfzinstruments/mappings
